//PropertyFinder.c: Search file files which have the specified properties, and print out their paths.
//Written by Xeno Kovah, Aug 2010
//Originally for use with MITRE Institute Life of Binaries class
//Licensed under Creative Commons Share Alike license.
//full details available here: http://creativecommons.org/licenses/by-sa/3.0
//P.s. Don't comment on the efficiency or style of the code, it's tutorial code! :P
//Also I know I'm not catching all the error conditions, and I don't care

#include <stdio.h>
#include <windows.h>
#include <string>
#include <vector>
#include <iostream>
#include "PropertyFinder.h"

using namespace std;

void main(){
	unsigned int input, maxFiles;

	while(1){
		input = 0;
		printf("Enter a command number:\n");
		printf("0: Quit\n");
		printf("1: Whatever I want it to be\n");
		printf("2: Files with non-zero IMAGE_DIRECTORY_ENTRY_IMPORT\n");
		printf("3: Files with non-zero IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT\n");
		printf("4: Files with non-zero IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT\n");
		printf("5: Files with non-zero IMAGE_DIRECTORY_ENTRY_EXPORT\n");
		printf("6: Files with non-zero IMAGE_DIRECTORY_ENTRY_TLS\n");
		printf("7: Files with non-zero IMAGE_DIRECTORY_ENTRY_SECURITY\n");
		printf("8: Files with non-zero IMAGE_DIRECTORY_ENTRY_BASERELOC\n");
		printf("9: Files with non-zero IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR\n");
		printf("10: Files with non-zero IMAGE_DIRECTORY_ENTRY_COPYRIGHT/IMAGE_DIRECTORY_ENTRY_ARCHITECTURE\n");

//		printf("10: Traverse directories starting at C:\\\n");
		printf("11: Files with only normal imports\n");

		while(!(cin >> input)){
			cin.clear();
			string s;
			cin >> s;
			cout << s << " is pretty clearly not an acceptable input\n";
		}
		if(input > 21){
			printf("Invalid command number entered. input = %d Try again.\n", input);
			continue;
		}
		if(input == 0){
			exit(0);
		}
		printf("You entered %d\n", input);

		printf("Enter number of files to print before stopping?:\n");

		while(!(cin >> maxFiles)){
			cin.clear();
			string s;
			cin >> s;
			cout << s << " is pretty clearly not an acceptable input\n";
		}
		printf("%d files to be printed\n", maxFiles);

		int ret = 0;
		switch(input){
			case 1:
				RecursiveSearchForProperty(&maxFiles, "C:\\WINDOWS\\System32\\", ScratchSearch);
				break;
			case 2:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\WINDOWS\\System32\\", IMAGE_DIRECTORY_ENTRY_IMPORT);
				break;
			case 3:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\WINDOWS\\System32\\", IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT);
				break;
			case 4:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\WINDOWS\\System32\\", IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT);
				break;
			case 5:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\", IMAGE_DIRECTORY_ENTRY_EXPORT);
				break;
			case 6:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\WINDOWS\\System32\\", IMAGE_DIRECTORY_ENTRY_TLS);
				break;
			case 7:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\WINDOWS\\System32\\", IMAGE_DIRECTORY_ENTRY_SECURITY);
				break;
			case 8:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\WINDOWS\\System32\\", IMAGE_DIRECTORY_ENTRY_BASERELOC);
				break;
			case 9:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\WINDOWS\\System32\\", IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR);
				break;
			case 10:
				RecursiveSearchForNonZeroIndex(&maxFiles, "C:\\WINDOWS\\System32\\", IMAGE_DIRECTORY_ENTRY_GLOBALPTR);
				break;
			//case 10:
			//	TraverseDirectories(&maxFiles, "C:\\");
			//	break;
			case 11:
				RecursiveSearchForProperty(&maxFiles, "C:\\WINDOWS\\System32\\", PrintNameIfOnlyRegularImports);
				break;
			default:
				printf("Now you gone an dun it. I'm outta here man, you clean up this mess yourself!");
				exit(-1);
		}
	
	}
}

////Depth-first recursive search
//void TraverseDirectories(unsigned int * maxFiles, const char * path){
//	WIN32_FIND_DATA bla;
//
//	string sPathOrig(path);
//	string sPathSearch(path);
//	string sPathTmp(path);
//	sPathSearch = sPathSearch + "*";
//
//	if(*maxFiles == 0){
//		return;
//	}
//
//	HANDLE ret = FindFirstFile(sPathSearch.c_str(), &bla);
//	if(ret == INVALID_HANDLE_VALUE){
//		return;
//	}
//	sPathTmp = sPathOrig + bla.cFileName;
//	if(bla.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
//		//Just skip some of the cygwin files, don't print them or traverse into them
//		if(strcmp(bla.cFileName, ".") != 0 && strcmp(bla.cFileName, "..") != 0 && strcmp(bla.cFileName, ".svn") != 0){
//			printf("Directory: %s\n", sPathTmp.c_str());
//			(*maxFiles)--;
//			if(*maxFiles == 0){return;}
//			sPathTmp = sPathTmp + "\\";
//			TraverseDirectories(maxFiles, sPathTmp.c_str());
//		}
//	}else{
//		printf("%s\n", sPathTmp.c_str());
//		(*maxFiles)--;
//		if(*maxFiles == 0){return;}
//	}
//
//	while(*maxFiles > 0){
//		if(!FindNextFile(ret, &bla)){
//			return;
//		}
//		sPathTmp = sPathOrig + bla.cFileName;
//		if(bla.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
//			//Just skip some of the cygwin files, don't print them or traverse into them
//			if(strcmp(bla.cFileName, ".") != 0 && strcmp(bla.cFileName, "..") != 0 && strcmp(bla.cFileName, ".svn") != 0){
//				printf("Directory: %s\n", sPathTmp.c_str());
//				(*maxFiles)--;
//				if(*maxFiles == 0){return;}
//				sPathTmp = sPathTmp + "\\";
//				TraverseDirectories(maxFiles, sPathTmp.c_str());
//			}
//		}else{
//			printf("%s\n", sPathTmp.c_str());
//			(*maxFiles)--;
//			if(*maxFiles == 0){return;}
//		}
//	}
//}

//Depth-first recursive search
void RecursiveSearchForNonZeroIndex(unsigned int * maxFiles, const char * path, unsigned char index){
	WIN32_FIND_DATA bla;

	string sPathOrig(path);
	string sPathSearch(path);
	string sPathTmp(path);
	sPathSearch = sPathSearch + "*";

	if(*maxFiles == 0){
		return;
	}

	HANDLE ret = FindFirstFile(sPathSearch.c_str(), &bla);
	if(ret == INVALID_HANDLE_VALUE){
		return;
	}
	sPathTmp = sPathOrig + bla.cFileName;
	if(bla.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
		//Just skip some of the cygwin files, don't print them or traverse into them
		if(strcmp(bla.cFileName, ".") != 0 && strcmp(bla.cFileName, "..") != 0 && strcmp(bla.cFileName, ".svn") != 0){
			sPathTmp = sPathTmp + "\\";
			//printf("Recursing into %s\n", sPathTmp.c_str());
			RecursiveSearchForNonZeroIndex(maxFiles, sPathTmp.c_str(), index);
		}
	}else{
		PrintNameIfNonZeroDirectoryEntryIndex(maxFiles, index, (char *)(sPathTmp.c_str()));
	}

	while(*maxFiles > 0){
		if(!FindNextFile(ret, &bla)){
			return;
		}
		sPathTmp = sPathOrig + bla.cFileName;
		if(bla.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			//Just skip some of the cygwin files, don't print them or traverse into them
			if(strcmp(bla.cFileName, ".") != 0 && strcmp(bla.cFileName, "..") != 0 && strcmp(bla.cFileName, ".svn") != 0){
				sPathTmp = sPathTmp + "\\";
				//printf("Recursing into %s\n", sPathTmp.c_str());
				RecursiveSearchForNonZeroIndex(maxFiles, sPathTmp.c_str(), index);
			}
		}else{
			PrintNameIfNonZeroDirectoryEntryIndex(maxFiles, index, (char *)(sPathTmp.c_str()));
		}
	}
}

//Depth-first recursive search
void RecursiveSearchForProperty(unsigned int * maxFiles, const char * path, void (*funcPtr)(unsigned int *, char *)){
	WIN32_FIND_DATA bla;

	string sPathOrig(path);
	string sPathSearch(path);
	string sPathTmp(path);
	sPathSearch = sPathSearch + "*.exe";

	if(*maxFiles == 0){
		return;
	}

	HANDLE ret = FindFirstFile(sPathSearch.c_str(), &bla);
	if(ret == INVALID_HANDLE_VALUE){
		return;
	}
	sPathTmp = sPathOrig + bla.cFileName;
	if(bla.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
		//Just skip some of the cygwin files, don't print them or traverse into them
		if(strcmp(bla.cFileName, ".") != 0 && strcmp(bla.cFileName, "..") != 0 && strcmp(bla.cFileName, ".svn") != 0){
			sPathTmp = sPathTmp + "\\";
			//printf("Recursing into %s\n", sPathTmp.c_str());
			RecursiveSearchForProperty(maxFiles, sPathTmp.c_str(), funcPtr);
		}
	}else{
		funcPtr(maxFiles, (char *)(sPathTmp.c_str()));
	}

	while(*maxFiles > 0){
		if(!FindNextFile(ret, &bla)){
			return;
		}
		sPathTmp = sPathOrig + bla.cFileName;
		if(bla.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			//Just skip some of the cygwin files, don't print them or traverse into them
			if(strcmp(bla.cFileName, ".") != 0 && strcmp(bla.cFileName, "..") != 0 && strcmp(bla.cFileName, ".svn") != 0){
				sPathTmp = sPathTmp + "\\";
				//printf("Recursing into %s\n", sPathTmp.c_str());
				RecursiveSearchForProperty(maxFiles, sPathTmp.c_str(), funcPtr);
			}
		}else{
			funcPtr(maxFiles, (char *)(sPathTmp.c_str()));
		}
	}
}

void PrintNameIfOnlyRegularImports(unsigned int * maxFiles, char * fullName){
	char bigBuffer[0x1000];
	FILE * tmpStream;
	PIMAGE_DOS_HEADER dosHeader;
	PIMAGE_NT_HEADERS ntHeader;

	errno_t err = fopen_s(&tmpStream, fullName,"rb");
	if(err != 0){
		//printf("PrintNameIfNonZeroImports: fopen_s error\n");
		return;
	}

	unsigned int bytesRead = fread(bigBuffer, sizeof(char), 0x1000, tmpStream);
	if(bytesRead != 0x1000){
		//printf("PrintNameIfNonZeroImports: fread error\n");
		return;
	}
	
	dosHeader = (PIMAGE_DOS_HEADER)bigBuffer;
	//the e_ip check is to skip things like dosx.exe which seem to be actual dos executables
	if(dosHeader->e_magic != IMAGE_DOS_SIGNATURE || dosHeader->e_ip != 0){
		return;
	}
	ntHeader = (PIMAGE_NT_HEADERS)(bigBuffer + dosHeader->e_lfanew);
	if(ntHeader->Signature != IMAGE_NT_SIGNATURE){
		return;
	}

	//Print the file name iff it matches our condition
	if(ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress != 0 && 
		ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT].VirtualAddress == 0 && 
		ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT].VirtualAddress == 0)
	{
		printf("%d\t%s\n", *maxFiles, fullName);
		(*maxFiles)--;
	}

	fclose(tmpStream);
}

void PrintNameIfNonZeroDirectoryEntryIndex(unsigned int * maxFiles, unsigned char index, char * fullName){
	char bigBuffer[0x1000];
	FILE * tmpStream;
	PIMAGE_DOS_HEADER dosHeader;
	PIMAGE_NT_HEADERS ntHeader;

	errno_t err = fopen_s(&tmpStream, fullName,"rb");
	if(err != 0){
		//printf("ScratchSearch: fopen_s error\n");
		return;
	}

	unsigned int bytesRead = fread(bigBuffer, sizeof(char), 0x1000, tmpStream);
	if(bytesRead != 0x1000){
		//printf("ScratchSearch: fread error\n");
		return;
	}
	
	dosHeader = (PIMAGE_DOS_HEADER)bigBuffer;
	//the e_ip check is to skip things like dosx.exe which seem to be actual dos executables
	if(dosHeader->e_magic != IMAGE_DOS_SIGNATURE || dosHeader->e_ip != 0){
		return;
	}
	ntHeader = (PIMAGE_NT_HEADERS)(bigBuffer + dosHeader->e_lfanew);
	if(ntHeader->Signature != IMAGE_NT_SIGNATURE){
		return;
	}

	//Print the file name iff it matches our condition
	if(ntHeader->OptionalHeader.DataDirectory[index].VirtualAddress != 0){
		printf("%d\t%s\n", *maxFiles, fullName);
		(*maxFiles)--;
	}

	fclose(tmpStream);
}

void ScratchSearch(unsigned int * maxFiles, char * fullName){
	char bigBuffer[0x1000];
	FILE * tmpStream;
	PIMAGE_DOS_HEADER dosHeader;
	PIMAGE_NT_HEADERS ntHeader;

	errno_t err = fopen_s(&tmpStream, fullName,"rb");
	if(err != 0){
		//printf("ScratchSearch: fopen_s error\n");
		return;
	}

	unsigned int bytesRead = fread(bigBuffer, sizeof(char), 0x1000, tmpStream);
	if(bytesRead != 0x1000){
		//printf("ScratchSearch: fread error\n");
		return;
	}
	
	dosHeader = (PIMAGE_DOS_HEADER)bigBuffer;
	//the e_ip check is to skip things like dosx.exe which seem to be actual dos executables
	if(dosHeader->e_magic != IMAGE_DOS_SIGNATURE || dosHeader->e_ip != 0){
		return;
	}
	ntHeader = (PIMAGE_NT_HEADERS)(bigBuffer + dosHeader->e_lfanew);
	if(ntHeader->Signature != IMAGE_NT_SIGNATURE){
		return;
	}

	//Print the file name iff it matches our condition
	if(ntHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR].VirtualAddress != 0){
		printf("%d\t%s\n", *maxFiles, fullName);
		(*maxFiles)--;
	}

	fclose(tmpStream);
}